<div class="page-header">
  <h3 class="page-title">
    <span class="page-title-icon bg-gradient-primary text-white mr-2">
      <i class="mdi mdi-cake"></i>
    </span>
    Productos
  </h3>
  <nav aria-label="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a routerLink="/dashboard">Inicio</a></li>
      <li class="breadcrumb-item active" aria-current="page">Productos</li>
    </ol>
  </nav>
</div>
<!-- boton  -->
<div class="row d-flex justify-content-between align-items-baseline" style="margin-right:auto; margin-left:auto;">
  <div>
    
  </div>
  <div class="row">
    <button type="button" class="btn btn-dark btn-fw" (click)="openModalCrear(MC)">
      <i class="mdi mdi-plus-box">Crear producto</i>
    </button>
    <button type="button" class="btn btn-dark btn-fw" (click)="valorizarInventario()">
      <i class="mdi mdi-plus-box"> Valorizar inventario</i>
    </button>
  </div>
</div>
<!-- boton -->
<!-- Inicio de table -->
<div class="row">
  <div class="col-md-12 grid-margin stretch-card">
    <div class="card">
      <div class="card-body">
        <div class="d-sm-flex align-items-center mb-4">
          <h4 class="card-title mb-sm-0">Listado de productos</h4>
        </div>
        <div class="table-responsive border rounded p-1">
          <table datatable [dtOptions]="dtOptions" [dtTrigger]="dtTrigger" class="table table-striped">
            <thead>
              <tr>
                <th class="font-weight-bold"></th>
                <th class="font-weight-bold">Nombre</th>
                <th class="font-weight-bold">Categoría</th>
                <th class="font-weight-bold">Descripción</th>
                <th class="font-weight-bold">Estado</th>
                <th class="font-weight-bold">Acciones</th>
              </tr>
            </thead>
            <tbody>
              <tr *ngFor="let item of itemProducts">
                <td>
                  <img src="{{this.obtenerImagen(item.imagen)}}">
                </td>
                <td>{{ item.nombre }}</td>
                <td>{{ item.categorium.nombre }}</td>
                <td>{{ item.descripcion }}</td>
                <td>
                  <div class="badge badge-success p-2" *ngIf="item.estado == 1">Visible</div>
                  <div class="badge badge-danger p-2" *ngIf="item.estado == 0">Oculto</div>
                </td>
                <td>
                  <button type="button" class="btn btn-danger btn-icon" (click)="eliminarProducto(item.id)" placement="bottom" ngbTooltip="Eliminar producto">
                    <i class="mdi mdi-delete-forever"></i>
                  </button>
                  <button type="button" class="btn btn-inverse-dark btn-icon"  (click)="editarProducto(item); openModalEditar(MEditar)" placement="bottom" ngbTooltip="Editar producto">
                    <i class="mdi mdi-grease-pencil" ></i>
                  </button>
                  <button type="button" class="btn btn-inverse-success btn-icon" *ngIf="item.estado == 0" (click)="activar(item.id)" placement="bottom" ngbTooltip="Activar producto">
                    <i class="mdi mdi-check"></i>
                  </button>
                  <button type="button" class="btn btn-inverse-danger btn-icon" *ngIf="item.estado == 1" (click)="desactivar(item.id)" placement="bottom" ngbTooltip="Desactivar producto">
                    <i class="mdi mdi-close"></i>
                  </button>
                  <button type="button" class="btn btn-success btn-icon" (click)="navigate(item)" placement="bottom" ngbTooltip="Ver formatos">
                    <i class="mdi mdi-book-plus" ></i>
                  </button>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>
</div>
<!-- Fin de table -->

<!-- Modal crear inicio -->
<ng-template class="modal fade" #MC let-modal>
  <div class="modal-content">
    <div class="modal-header">
      <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close" (click)="modal.dismiss()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="col-12 stretch-card">
        <div class="card-body" [formGroup]="productCreate">
          <h4 class="card-title">Crear producto</h4>
          <div class="form-group">
            <label for="categoria_id">Categoría</label>
            <div class="input-group mb-3">
              <div class="input-group-prepend">
              </div>
              <select class="custom-select" id="categoria_id" formControlName="categoria_id">
                <option selected [value]="null">Seleccione una categoría</option>
                <option *ngFor="let item of categorias" [value]="item.id">{{ item.nombre }}</option>
              </select>
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Nombre</label>
              <input type="text" class="form-control" id="exampleInputName2" placeholder="Ingrese un nombre" #nombre
                style="background-color:dark" formControlName="nombre">
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Descripción</label>
              <input type="text" class="form-control" id="exampleInputName2" placeholder="Ingrese una descripción"
                #descripcion style="background-color:dark" formControlName="descripcion">
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Imagen</label>
              <input (change)="fileChangeCreate(imagen.files); capturarFile($event)" type="file" class="form-control-file" id="exampleInputName2" 
                #imagen style="background-color:dark" formControlName="imagen">
            </div>
          </div>
          <div *ngIf="previsualizacion" >
            <img [src]="previsualizacion" width="250px" style="border-radius: 20px;" alt="">
          </div>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="submit" class="btn btn-primary mr-2"
        (click)="crearProducto(productCreate.value, modal)" [disabled]="this.productCreate.invalid">Crear</button>
      <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="modal.dismiss()">Cancelar</button>
    </div>
  </div>
</ng-template>

<!-- Modal crear rol final -->


<!-- Modal crear inicio -->
<ng-template class="modal fade" #MEditar let-modal>
  <div class="modal-content">
    <div class="modal-header">
      <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close" (click)="modal.dismiss()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="col-12 stretch-card">
        <div class="card-body" [formGroup]="productEdit">
          <h4 class="card-title">Editar producto</h4>
          <div class="form-group">
            <label for="categoria_id">Categoría</label>
            <div class="input-group mb-3">
              <div class="input-group-prepend">
              </div>
              <select class="custom-select" id="categoria_id" formControlName="categoria_id">
                <option selected [value]="null">Seleccione una categoría</option>
                <option *ngFor="let item of categorias" [value]="item.id">{{ item.nombre }}</option>
              </select>
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Nombre</label>
              <input type="text" class="form-control" id="exampleInputName2" placeholder="Ingrese un nombre" #nombre
                style="background-color:dark" formControlName="nombre">
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Descripción</label>
              <input type="text" class="form-control" id="exampleInputName2" placeholder="Ingrese una descripción"
                #descripcion style="background-color:dark" formControlName="descripcion">
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Imagen</label>
              <input (change)="fileChange(imagen.files); capturarFile($event)" type="file" class="form-control-file"
                id="exampleInputName2" #imagen style="background-color:dark" formControlName="imagen" >
            </div>
          </div>
          <div *ngIf="previsualizacion">
            <img [src]="this.previsualizacion" width="250px" style="border-radius: 20px;" alt="" >
          </div>
          <div *ngIf="!previsualizacion">
            <img [src]="this.imagenEdit" width="250px" style="border-radius: 20px;" alt="" >
          </div>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="submit" class="btn btn-primary mr-2"
        (click)="guardarEdit(productEdit.value, modal)" [disabled]="this.productEdit.invalid">Guardar</button>
      <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="modal.dismiss()">Cancelar</button>
    </div>
  </div>
</ng-template>

<!-- Modal crear rol final -->

